Subject: Re: #295: Applying original fragment to "plain" redirected URI (also #43)

From: Julian Reschke <[email-masked]>
Date: Fri, 30 Dec 2011 18:51:19 +0100

On 2011-05-27 05:32, Mark Nottingham wrote:
> New issue:<http://trac.tools.ietf.org/wg/httpbis/trac/ticket/295>
>
> As Eric Lawrence pointed out on his blog:
>    http://blogs.msdn.com/b/ieinternals/archive/2011/05/17/url-fragments-and-redirects-anchor-hash-missing.aspx
>
> we don't define what happens when a request-URI has a fragment identifier and is redirected, but the Location header payload doesn't.
>
> As mentioned in #43, an old I-D did specify behaviour here:
>   http://tools.ietf.org/html/draft-bos-http-redirect-00
>
> Specifically:
>
> """
> If the server returns a response code of 300 ("multiple choice"), 301 ("moved permanently"), 302 ("moved temporarily") or 303 ("see other"), and if the server also returns one or more URIs where the resource can be found, then the client SHOULD treat the new URIs as if the fragment identifier of the original URI was added at the end.
> """
>
> By my testing<https://gist.github.com/330963>*, IE (6 to 9)** and Safari do not apply the fragid (T4 and T8), whereas Opera, Chrome and Firefox do. If anyone has results from other implementations, they'd be most welcome.
>
> I see two possible ways forward:
>    1) As with #43, explicitly state that there isn't interop here.
>    2) Define interop along the lines of draft-bos-http-redirect.
>
> I realise that #2 would break some existing implementations, but I've seen evidence of some real interop pain here, and defining interop where the spec is cloudy *is* within our charter.
>
> However, I'd really like to hear from implementers as to whether they'd be willing to change their implementations before going down that path.
>
>
> Regarding #43<http://trac.tools.ietf.org/wg/httpbis/trac/ticket/43>, my most recent testing indicates that, putting aside T4 and T8, there *is* interop on fragment combination for IE6-9, Safari 5, Chrome (current), FF4, FF3.6.15, FF3.0.11, and Opera 11.10.

Indeed; see my tests at 
<http://greenbytes.de/tech/tc/httpredirects/#l-fragments> (note that 
Safari appears to have funny issues filling the iframes; but navigating 
to the linked resource gets you proper results).

And, in a later mail:

>> My concern is similar to what was brought up in the context of issue 43 -- it's not entirely clear whether HTTPbis has any business in defining this (that is; is this an aspect of media types or of redirects?).
>>
>> I don't think we ever came to a conclusion about this in the context of #43, as, in the end, we didn't define the behavior.
> My recollection was that we didn't have interop in browsers, and we didn't have an indication of a strong desire from them one way or the other. I'd say we have both now.
>
> Perhaps we should ping the TAG to get their thoughts? Absent strong objection, it seems like we can have an easy interop win here.

We could try (cc'ing Larry so he sees this), but we'd need a reply very 
soon :-)

Best regards, Julian